#pragma once

#include <QtCore/QSharedPointer>
#include <QtCore/QWeakPointer>
#include <QtCore/QUrl>
#include <QtCore/QObject>

#include <odb/database.hxx>

#pragma db object abstract
class DbObject: public QObject {
  Q_OBJECT
public:
  typedef unsigned long long Id;
  static const Id ID_NEW;

  #pragma db id auto
  Id id;

protected:
  DbObject(): id(ID_NEW) {}
  virtual ~DbObject() {}
};

/**
 * Some test structure to be serialized
 */
struct KludgyBool {  
  KludgyBool(): value(false) {}
  KludgyBool(const bool value_): value(value_) {}
  bool value;
};


#pragma db object
class Document : public DbObject {
  Q_OBJECT
public:
  typedef QSharedPointer<Document> Ptr;
  static Ptr load(odb::database& db);
  virtual void save(odb::database& db);

  #pragma db type("BLOB")
  KludgyBool data;
};
