#pragma once

#include "Document.hpp"
#include <odb/sqlite/traits.hxx>
#include <QtCore/QByteArray>
#include <QtCore/QBuffer>
#include <QtCore/QDataStream>

namespace odb {
namespace sqlite {


template<>
class value_traits<KludgyBool, id_blob> {
public:
  typedef KludgyBool value_type;
  typedef KludgyBool query_type;
  typedef details::buffer image_type;


  static void set_value(KludgyBool& out, const details::buffer& in, const std::size_t inSize, const bool isInNull) {
    out.value = !isInNull;
  }

  static void set_image(details::buffer& out, std::size_t& outSize, bool& isOutNull, const KludgyBool& in) {
    isOutNull = !in.value;
    /**
     * ACTUAL SIZE MAY BE ZERO, MAY BE NOT. DOESN'T MATTER
     */
    outSize = 0;
    out.capacity(0);
  }
};


}
}
